summaryrefslogtreecommitdiff
path: root/tests/rm
diff options
context:
space:
mode:
authorRob Day <robertkday@gmail.com>2012-08-22 23:04:19 +0100
committerJim Meyering <meyering@redhat.com>2012-08-23 20:53:04 +0200
commitdd22da8e9539cc88193987b6997769ae4ede2b15 (patch)
tree630d3469f4d7710c3252682a51f495eba1846924 /tests/rm
parentfadf9c525787f063e6fe84bdd5566e53a622c1ce (diff)
downloadcoreutils-dd22da8e9539cc88193987b6997769ae4ede2b15.tar.xz
rm: fix the new --dir (-d) option to work with -i
* src/remove.c (prompt): Hoist the computation of is_empty, since we'll need it slightly earlier. Before, this function would arrange to fail with EISDIR when processing a directory without --recursive (-r). Adjust the condition to exempt an empty directory when --dir has been specified. Improve comments. * tests/rm/d-3: New file, to ensure that rm -d -i dir works. * tests/Makefile.am (TESTS): Add it. * NEWS (Bug fixes): Mention it. * THANKS.in: Update. Reported by Michael Price in http://bugs.gnu.org/12260
Diffstat (limited to 'tests/rm')
-rwxr-xr-xtests/rm/d-337
1 files changed, 37 insertions, 0 deletions
diff --git a/tests/rm/d-3 b/tests/rm/d-3
new file mode 100755
index 000000000..2f2cf7492
--- /dev/null
+++ b/tests/rm/d-3
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Ensure that 'rm -d -i dir' (i.e., without --recursive) gives a prompt and
+# then deletes the directory if it is empty
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ rm
+
+mkdir d || framework_failure_
+
+echo "y" | rm -i -d --verbose d > out 2> out.err || fail=1
+printf "%s" \
+ "rm: remove directory 'd'? " \
+ > exp.err || framework_failure_
+
+printf "%s\n" \
+ "removed directory: 'd'" \
+ > exp || framework_failure_
+
+compare exp out || fail=1
+compare exp.err out.err || fail=1
+
+Exit $fail